package org.objectteams;

/**
 *  This exception is used by the language implementation
 *  to signal a failed lifting due to insufficient activation level.
 */
public class LiftingVetoException extends RuntimeException {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	Team aTeam = null;
	Object base = null;
	
	public LiftingVetoException(Team aTeam, Object base) {
		this.aTeam = aTeam;
		this.base = base;
	}
	
    public LiftingVetoException() {
		super("");
    }
    
	public String toString() {
		return "Team " + aTeam + " refuses to lift " + base
				+ "\n(this exception should not be seen in applications).";
	}
}
