package org.objectteams;

/**
 * TODO: add documentation
 */
public class WrongRoleException extends RuntimeException {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Class clazz;
	private Object base;
	private Object role;

	/**
	 * @param clazz
	 * @param base
	 * @param role
	 */
	public WrongRoleException (Class clazz, Object base, Object role) {
		this.clazz = clazz;
		this.base = base;
		this.role = role;
	}
	
	public String getMessage() {
		String baseClazz = base.getClass().getName();
		String roleClazz = role.getClass().getName();
		return "The compiler has warned you about ambiguous role bindings.\n"
				+ "Now lifting to " + clazz
				+ " fails with the following objects\n"
				+ "(see OT/J language definition para. 2.3.4(d)):\n"
				+ "Provided:\n  Base object: " + base + "\n" + "  Base type:   "
				+ baseClazz + "\n" 
				+ "Found in cache:\n  Role object: " + role + "\n"
				+ "  Role type:   " + roleClazz;
	}
}
