/*
 * Created on Dec 13, 2003
 */
package org.objectteams.transformer;

// ObjectTeams/Java Runtime System.
//Copyright (c) 2003 Stephan Herrmann.
//Project Home Page: http://www.ObjectTeams.org
//
//This program is free software.
//
//You may redistribute it and/or modify it under the terms of the
//GNU Lesser General Public License as published by the
//Free Software Foundation. Version 2.1 of the license should be
//included with this distribution in the file LICENSE.LGPL.
//If the license is not included with this distribution,
//you may find a copy at the FSF web site at 'www.gnu.org' or
//'www.fsf.org', or you may write to the Free Software Foundation,
//675 Mass Ave, Cambridge, MA 02139 USA.
//
//THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND,
//NOT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR
//OF THIS SOFTWARE, ASSUMES _NO_ RESPONSIBILITY FOR ANY
//CONSEQUENCE RESULTING FROM THE USE, MODIFICATION, OR
//REDISTRIBUTION OF THIS SOFTWARE.

/**
 * @author stephan 
 */
public class OTREInternalError extends Error {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static final String _bugmsg = 
        "An error occurred in the Object Teams runtime environment.\n"+
        "We would appreciate if you send a bug report to support@ObjectTeams.org.\n"+
        "Please include your program (if possible) and the following diagnostic\n"+
        "in your report. -- Thank you. The ObjectTeams/Java developers\n";
    /**
     * 
     */
    public OTREInternalError() {
        super(_bugmsg);
    }

    /**
     * @param message
     */
    public OTREInternalError(String message) {
        super(_bugmsg+message);
    }

    /**
     * @param cause
     */
    public OTREInternalError(Throwable cause) {
        super(_bugmsg+cause.toString());
    }

    /**
     * @param message
     * @param cause
     */
    public OTREInternalError(String message, Throwable cause) {
        super(_bugmsg+message+cause.toString());
    }

}
