package org.objectteams.transformer.jmangler;

import java.util.Iterator;

import org.cs3.jmangler.supplier.UnextendableClassSet;
import org.cs3.jmangler.tau.ExtensionSet;
import org.cs3.jmangler.tau.InterfaceTransformerComponent;
import org.objectteams.transformer.Decapsulation;
import org.objectteams.transformer.Decapsulation.SharedState;

import de.fub.bytecode.Constants;
import de.fub.bytecode.generic.ClassGen;

// ObjectTeams/Java Runtime System.
// Copyright (c) 2003 Stephan Herrmann.
// Project Home Page: http://www.ObjectTeams.org
//
// This program is free software.
//
// You may redistribute it and/or modify it under the terms of the
// GNU Lesser General Public License as published by the
// Free Software Foundation. Version 2.1 of the license should be
// included with this distribution in the file LICENSE.LGPL.
// If the license is not included with this distribution,
// you may find a copy at the FSF web site at 'www.gnu.org' or
//  'www.fsf.org', or you may write to the Free Software Foundation,
// 675 Mass Ave, Cambridge, MA 02139 USA.
//
// THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND,
// NOT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR
// OF THIS SOFTWARE, ASSUMES _NO_ RESPONSIBILITY FOR ANY
// CONSEQUENCE RESULTING FROM THE USE, MODIFICATION, OR
// REDISTRIBUTION OF THIS SOFTWARE.

/**
 *  For each base method that is bound by callout and has
 *  insufficient visibility, the visibility is set to public.
 *  If the corresponding JMangler-patch is installed, check
 *  whether the affected base class resides in a sealed package.
 *  In that case dissallow decapsulation by throwing an IllegalAccessError.
 *  @author Stephan Herrmann
 */

public class Decapsulator 
	extends ObjectTeamsTransformer
	implements InterfaceTransformerComponent, Constants 
	//, CodeTransformerComponent
{

	private Decapsulation transformation = new Decapsulation(new SharedState());
	/**
	 * Main entry for this transformer.
	 */
    public ExtensionSet transformInterface(UnextendableClassSet cs) {

        Iterator iter = cs.getIteratorForTransformableClasses();
        ExtensionSet es = new ExtensionSet();
        JManglerEnhancer jme = new JManglerEnhancer(this, es, cs);
        
        while (iter.hasNext()) {
            // look at every transformable class
            ClassGen        cg         = (ClassGen)iter.next();
            
            transformation.doTransformInterface(jme, cg);
		}
		return es;
	}


}
