package org.objectteams.transformer.jmangler;

import org.cs3.jmangler.tau.InterfaceTransformerComponent;
import org.objectteams.transformer.OTConstants;

// ObjectTeams/Java Runtime System.
// Copyright (c) 2002 Christine Hundt, 2003 Stephan Herrmann, 2004 Christine Hundt.
// Project Home Page: http://www.ObjectTeams.org
//
// This program is free software.
//
// You may redistribute it and/or modify it under the terms of the
// GNU Lesser General Public License as published by the
// Free Software Foundation. Version 2.1 of the license should be
// included with this distribution in the file LICENSE.LGPL.
// If the license is not included with this distribution,
// you may find a copy at the FSF web site at 'www.gnu.org' or
//  'www.fsf.org', or you may write to the Free Software Foundation,
// 675 Mass Ave, Cambridge, MA 02139 USA.
//
// THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND,
// NOT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR
// OF THIS SOFTWARE, ASSUMES _NO_ RESPONSIBILITY FOR ANY
// CONSEQUENCE RESULTING FROM THE USE, MODIFICATION, OR
// REDISTRIBUTION OF THIS SOFTWARE.


/**
 * Superclass for all jmangler transformers in this package.
 * Contains common fields and methods.
 *
 * @version $Id: ObjectTeamsTransformer.java,v 1.5 2006-10-09 16:00:05 resix Exp $
 * @author   Christine Hundt, Stephan Herrmann
 */
public abstract class ObjectTeamsTransformer
	implements InterfaceTransformerComponent, OTConstants
{

	// ----------------------------------------------------
	// ---------- Messages in the JMangler protocol: ------
	// ----------------------------------------------------

	/** Empty implementation of JMangler protocol. */
    public void sessionStart() {} 

	/** Empty implementation of JMangler protocol. */
    public void sessionEnd() {}

	/** Minimal implementation of JMangler protocol. */
    public String verboseMessage() { 
    // give the class name in startup message
        return toString();
    }
}
