package org.objectteams.transformer.jmangler;

import java.util.Iterator;

import org.cs3.jmangler.supplier.UnextendableClassSet;
import org.cs3.jmangler.tau.ExtensionSet;
import org.cs3.jmangler.tau.InterfaceTransformerComponent;
import org.objectteams.transformer.SubBoundBaseMethodRedefinition;
import org.objectteams.transformer.ObjectTeamsTransformation.SharedState;

import de.fub.bytecode.generic.ClassGen;

// ObjectTeams/Java Runtime System.
// Copyright (c) 2002 Christine Hundt, 2003 Stephan Herrmann, 2004 Christine Hundt.
// Project Home Page: http://www.ObjectTeams.org
//
// This program is free software.
//
// You may redistribute it and/or modify it under the terms of the
// GNU Lesser General Public License as published by the
// Free Software Foundation. Version 2.1 of the license should be
// included with this distribution in the file LICENSE.LGPL.
// If the license is not included with this distribution,
// you may find a copy at the FSF web site at 'www.gnu.org' or
//  'www.fsf.org', or you may write to the Free Software Foundation,
// 675 Mass Ave, Cambridge, MA 02139 USA.
//
// THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY OF ANY KIND,
// NOT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY. THE AUTHOR
// OF THIS SOFTWARE, ASSUMES _NO_ RESPONSIBILITY FOR ANY
// CONSEQUENCE RESULTING FROM THE USE, MODIFICATION, OR
// REDISTRIBUTION OF THIS SOFTWARE.

/**
 * Redefines inherited (and not redefined) base methods in subclasses with a call to the super method if they
 * are bound for the subclass only. 
 * This is done in order to provide a place for the BaseMethodTransformer to weave in the callin code.
 * 
 * @version $Id: SubBoundBaseMethodRedefiner.java,v 1.4 2006-10-09 16:00:05 resix Exp $
 * @author  Christine Hundt, Stephan Herrmann
 */

public class SubBoundBaseMethodRedefiner
	extends ObjectTeamsTransformer
	implements InterfaceTransformerComponent
{
	private SubBoundBaseMethodRedefinition transformation = new SubBoundBaseMethodRedefinition(new SharedState());

	/**
	 * Main entry for this transformer.
	 */
    public ExtensionSet transformInterface(UnextendableClassSet cs) {
        Iterator iter = cs.getIteratorForTransformableClasses();
        ExtensionSet es = new ExtensionSet();
        JManglerEnhancer jme = new JManglerEnhancer(this, es, cs);

        while (iter.hasNext()) {
            // look at every transformable class
            ClassGen        cg         = (ClassGen)iter.next();
//            String          class_name = cg.getClassName();
//            ConstantPoolGen cpg        = cg.getConstantPool();
           
            // convert 'cg' to BCEL 5.1 version --->
//            org.apache.bcel.generic.ClassGen new_cg;
//            org.apache.bcel.classfile.JavaClass new_class = null;
//			try {
//				new_class = new org.apache.bcel.classfile.ClassParser(new ByteArrayInputStream(cg.getJavaClass().getBytes()), class_name).parse();
//			} catch (ClassFormatException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			} catch (IOException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			}
//			new_cg = new org.apache.bcel.generic.ClassGen(new_class);
			// <--- convert 'cg' to BCEL 5.1 version.
			
            transformation.doTransformInterface(jme, cg);
        }
        // return the changes
        return es;
    }
}
